/**
 * InfoPanel - shows a variety of Solaris information
 * @author Peter Tribble
 * @version 1.0
 *
 */

package uk.co.petertribble.solview;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class InfoPanel extends JPanel {
  
  JList ilist;
  JEditorPane tp;
  InfoCommandList iclist;

  /**
   * Display an information panel
   */
  public InfoPanel() {
    setLayout(new BorderLayout());
    iclist = new InfoCommandList();
    ilist = new JList(iclist);
    ilist.addMouseListener(mouseListener);
    JScrollPane scrollPane = new JScrollPane(ilist);
    tp = new JEditorPane();
    tp.setContentType("text/html");
    JSplitPane psplit = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scrollPane,new JScrollPane(tp));
    psplit.setOneTouchExpandable(true);
    psplit.setDividerLocation(120);
    add(psplit);
  }

  MouseListener mouseListener = new MouseAdapter() {
    public void mouseClicked(MouseEvent e) {
      Cursor c = getCursor();
      setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      JList source = (JList) e.getSource();
      tp.setText(iclist.infoTable((InfoCommand) source.getSelectedValue()));
      tp.setMargin(new Insets(5,5,5,5));
      tp.setCaretPosition(0);
      tp.setEditable(false);
      setCursor(c);
    }
  };

}
