/**
 * RunCommand - run a command and return the output
 * @author Peter Tribble
 * @version 1.0
 *
 */

package uk.co.petertribble.solview.helpers;

import java.io.*;

public class RunCommand {

  private String stdout;
  private String stderr;
  private String status;
  private boolean successful;

  public RunCommand(String cmd) {
    Runtime rt = Runtime.getRuntime();
    StringBuffer stdoutBuffer = new StringBuffer();
    StringBuffer stderrBuffer = new StringBuffer();
    try {
      Process p = rt.exec(cmd, (String[]) null, new File("/tmp"));
      //the api docs say we should buffer all i/o
      String s;
      InputStream stream1 = p.getInputStream();
      BufferedReader reader1 = new BufferedReader(new InputStreamReader(stream1));
      InputStream stream2 = p.getErrorStream();
      BufferedReader reader2 = new BufferedReader(new InputStreamReader(stream2));
      while ((s = reader1.readLine()) != null) {
	stdoutBuffer.append(s).append("\n");
      }
      while ((s = reader2.readLine()) != null) {
	stderrBuffer.append(s).append("\n");
      }
      try {
        p.waitFor();
        status = Integer.toString(p.exitValue());
	successful = true;
      } catch (InterruptedException ie) {
        successful = false;
      }
      reader1.close();
      reader2.close();
    } catch (IOException ioe) {
      successful = false;
    }
    stdout = stdoutBuffer.toString();
    stderr = stderrBuffer.toString();
  }

  public String getOut() {
    return stdout;
  }
  public String getErr() {
    return stderr;
  }
  public String getStatus() {
    return status;
  }
  public boolean succeeded() {
    return successful;
  }
}
